#! /usr/bin/python3

import sys
import os
import subprocess

PARSING, LOCAL, REMOTE = range(3)

DIFFTOOL = "meld"

def main(input_path):
    state = PARSING
    fin = open(input_path)
    path_local = "%s.local" % input_path
    path_remote = "%s.remote" % input_path
    fout_local = open(path_local, 'w')
    fout_remote = open(path_remote, 'w')
    c = 0
    
    for line in fin:
        if state == PARSING:
            if line.startswith("<<<<<<< "):
                state = LOCAL
                c += 1
            else:
                for fout in fout_local, fout_remote:
                    fout.write(line)
        
        
        elif state == LOCAL:
            if line.strip() == "=======":
                state = REMOTE
            else:
                fout_local.write(line)
        
        elif state == REMOTE:
            if line.startswith(">>>>>>> "):
                state = PARSING
            else:
                fout_remote.write(line)
    
    for fout in fout_local, fout_remote:
        fout.close()
    fin.close()
    assert(state == PARSING), "Finished parsing in state %s!" % ("LOCAL", "REMOTE")[state-1]
    print("Done, %d blocks" % c)
    subprocess.call([DIFFTOOL, path_local, path_remote])
    os.rename(path_local, input_path)
    os.remove(path_remote)

if __name__ == '__main__':
    main(sys.argv[1])
